CXX = g++

# GSL installation directories
GSL_VERSION = $(shell gsl-config --version)
dir_INC_GSL = $(shell gsl-config --prefix)/include/
dir_LIB_GSL = $(shell gsl-config --prefix)/lib/

# FFTW installation directories
dir_INC_FFTW = /usr/local/include/
dir_LIB_FFTW =/usr/local/lib/

# boost installation directories
dir_INC_BOOST = /usr/local/include/
dir_LIB_BOOST = /usr/local/lib/

FLAGS0 = -std=c++11 -fopenmp
FLAGS = -O3 -unroll -Wall -Wextra -pedantic -Wfatal-errors -Werror -Wno-unused-variable

dirLib = $(HOME)/CosmoBolognaLib/
dirH = $(dirLib)Headers/
dir_Eigen = $(dirLib)External/Eigen/eigen-3.3.7/
dir_CCfits = $(dirLib)External/CCfits/include
dirCUBA = $(dirLib)External/Cuba-4.2/

varDIR = -DDIRCOSMO=\"$(dirLib)\" -DDIRL=\"$(PWD)/\"

FLAGS_LIB = -Wl,-rpath,$(DIR_MODEL)  -L$(DIR_MODEL) -lMODEL
FLAGS_LIB := $(FLAGS_LIB) -Wl,-rpath,$(dirLib) -L$(dirLib) -lCBL -lgsl -lgslcblas -lm
FLAGS_INC = -I$(dirH) -I$(dirCUBA) -I$(dir_Eigen) -I$(dir_CCfits) -I$(dir_INC_GSL) -I$(dir_INC_FFTW) -isystem$(dir_INC_BOOST)

OBJ1 = pk_SPT.o
OBJ2 = pk_bias.o
OBJ3 = pk_TNS.o

ES = so

SYS:=$(shell uname -s)

ifeq ($(SYS),Darwin)
        ES = dylib
endif

all: pk_SPT pk_bias pk_TNS

pk_SPT: $(OBJ1)
	$(CXX) $(OBJ1) -o pk_SPT.exe $(FLAGS_LIB)

pk_bias: $(OBJ2)
	$(CXX) $(OBJ2) -o pk_bias.exe $(FLAGS_LIB)

pk_TNS: $(OBJ3)
	$(CXX) $(OBJ3) -o pk_TNS.exe $(FLAGS_LIB)

clean:
	rm -f *.o *.exe *~ \#* temp* core*

pk_SPT.o: pk_SPT.cpp makefile $(dirLib)*.$(ES)
	$(CXX) $(FLAGS0) $(FLAGS) $(FLAGS_INC) $(varDIR) -c pk_SPT.cpp

pk_bias.o: pk_bias.cpp makefile $(dirLib)*.$(ES)
	$(CXX) $(FLAGS0) $(FLAGS) $(FLAGS_INC) $(varDIR) -c pk_bias.cpp

pk_TNS.o: pk_TNS.cpp makefile $(dirLib)*.$(ES)
	$(CXX) $(FLAGS0) $(FLAGS) $(FLAGS_INC) $(varDIR) -c pk_TNS.cpp
